<template>
  <v-container id="sale-storage">
    <base-material-card
      :items-per-page="5"
      :single-select="true"
      color="success"
      icon="mdi-store"
      title="BÁN HÀNG"
      class="px-5 py-3"
      show-select
    >
      <!-- Control -->
      <v-form ref="form">
        <v-row>
          <v-col
            cols="12"
            lg="12"
            class="pb-0 text-right"
          >
            <v-btn
              color="primary"
              class="mr-1"
              width="120"
            >
              Lưu hóa đơn
              <v-icon right>
                save
              </v-icon>
            </v-btn>
            <v-btn
              color="warning"
              width="120"
              class="mr-1"
            >
              In hóa đơn
              <v-icon right>
                print
              </v-icon>
            </v-btn>
            <v-btn
              color="error"
              width="80"
              class="mr-0"
            >
              Back
              <v-icon right>
                close
              </v-icon>
            </v-btn>
          </v-col>
        </v-row>

        <v-divider class="mt-2" />
        <!-- THÔNG TIN KHÁCH hàng -->
        <v-row>
          <v-col
            cols="12"
            lg="12"
          >
            <div>
              <v-expansion-panels
                v-model="panel"
                :readonly="readonly"
                multiple
              >
                <v-expansion-panel>
                  <v-expansion-panel-header>
                    <h3>
                      THÔNG TIN KHÁCH HÀNG - GIAO HÀNG
                    </h3>
                  </v-expansion-panel-header>
                  <v-expansion-panel-content>
                    <v-row>
                      <!-- Nguoi mua -->
                      <v-col
                        cols="12"
                        md="6"
                        class="light-gray pb-0 pt-0"
                      >
                        <v-row>
                          <v-col
                            cols="12"
                            lg="12"
                            class="light-gray pb-0 pt-0"
                          >
                            <v-autocomplete
                              v-model="customerModel.name"
                              :items="customerList"
                              ref="customerOrder"
                              :search-input.sync="searchInput"
                              return-object
                              item-text="name"
                              label="Họ tên người mua (*)"
                              :rules="nameRules"
                              required
                              clearable
                              @change="customerChange($event)"
                            />
                          </v-col>
                          <v-col
                            cols="12"
                            lg="12"
                            class="light-gray pb-0 pt-0"
                          >
                            <v-text-field
                              ref="codeproduct"
                              v-model="customerModel.phone"
                              label="Số ĐT"
                              required
                              :rules="nameRules"
                            />
                          </v-col>

                          <v-col
                            cols="12"
                            lg="12"
                            class="light-gray pb-0 pt-0"
                          >
                            <v-text-field
                              ref="codeproduct"
                              v-model="customerModel.address"
                              label="Địa chỉ"
                              required
                              :rules="nameRules"
                            />
                          </v-col>
                        </v-row>
                      </v-col>

                      <!-- Nguoi nhận -->
                      <v-col
                        cols="12"
                        md="6"
                        class="light-gray pb-0 pt-0"
                      >
                        <v-row>
                          <v-col
                            cols="12"
                            lg="8"
                            class="light-gray pb-0 pt-0"
                          >
                            <v-autocomplete
                               v-model="customerModel.delivery_name"
                              :items="customerList"
                              ref="customerdeliveryname"
                              :search-input.sync="searchInput"
                              return-object
                              item-text="name"
                              label="Họ tên người nhận (*)"
                              :rules="nameRules"
                              required
                              clearable
                              @change="customerChange($event)"
                            />
                          </v-col>
                          <v-col
                            cols="12"
                            lg="4"
                            class="light-gray pb-0 pt-0"
                          >
                            <v-text-field
                              ref="codeproduct"
                              v-model="customerModel.delivery_phone"
                              label="ĐT giao hàng"
                              required
                              :rules="nameRules"
                            />
                          </v-col>

                          <v-col
                            cols="12"
                            lg="12"
                            class="light-gray pb-0 pt-0"
                          >
                            <v-text-field
                              ref="codeproduct"
                              v-model="customerModel.delivery_address"
                              label="Địa chỉ"
                              required
                              :rules="nameRules"
                            />
                          </v-col>
                          <v-col
                            cols="12"
                            lg="12"
                            class="light-gray pb-0 pt-0"
                          >
                            <v-text-field
                              ref="codeproduct"
                              v-model="customerModel.delivery_time"
                              label="Thời gian giao hàng"
                              required
                              :rules="nameRules"
                            />
                          </v-col>
                        </v-row>
                      </v-col>
                    </v-row>
                  </v-expansion-panel-content>
                </v-expansion-panel>

                <v-expansion-panel>
                  <v-expansion-panel-header>
                    <h3>
                      THÔNG TIN SẢN PHẨM
                    </h3>
                  </v-expansion-panel-header>
                  <v-expansion-panel-content>
                    <!-- FORM THÔNG TIN -->
                    <v-row>
                      <v-col
                        cols="12"
                        md="7"
                        class="light-gray pb-0 pt-0"
                      >
                        <v-autocomplete
                          v-model="customerModel.delivery_name"
                          :items="customerList"
                          ref="customerdeliveryname"
                          :search-input.sync="searchInput"
                          return-object
                          item-text="name"
                          label="Tên sản phẩm (*)"
                          :rules="nameRules"
                          required
                          clearable
                          @change="customerChange($event)"
                        />
                      </v-col>
                      <v-col
                        cols="12"
                        md="2"
                        class="light-gray pb-0 pt-0"
                      >
                        <v-autocomplete
                          v-model="customerModel.delivery_name"
                          :items="specs"
                          ref="customerdeliveryname"
                          :search-input.sync="searchInput"
                          return-object
                          item-text="name"
                          label="ĐVT"
                          :rules="specRule"
                          required
                          clearable
                           @change="productChange($event)"
                        />
                      </v-col>

                      <v-col
                        cols="12"
                        md="2"
                        class="light-gray pb-0 pt-0"
                      >
                        <v-text-field
                            ref="codeproduct"
                            v-model="customerModel.delivery_time"
                            label="Số lượng"
                            required
                            :rules="nameRules"
                          />
                      </v-col>
                      <v-col
                        cols="12"
                        md="1"
                        class="pr-6"
                      >
                        <v-btn
                          color="primary"
                          class="text-center"
                          width="50px"
                          height="35px"
                        >
                          <v-icon>
                            add
                          </v-icon>
                        </v-btn>
                      </v-col>
                    </v-row>
                    <!-- SẢN PHẨM ĐÃ CHỌN -->
                    <v-row>
                      <v-col
                        cols="12"
                        md="7"
                        class="light-gray pb-0 pb-0"
                      >
                        DANH SÁCH SẢN PHẨM
                      </v-col>
                      <v-col
                        cols="12"
                        md="12"
                        class="light-gray pb-0 pt-0"
                      >
                        <v-data-table
                          v-model="selected"
                          :headers="headers"
                          :items="productList"
                          :single-select="singleSelect"
                          :search="search"
                          class="elevation-1 table-list"
                          show-select
                          fixed-header
                          height="510"
                        >
                          <!-- Search -->
                          <template v-slot:top>
                            <v-text-field
                              v-model="search"
                              label="Tìm kiếm theo tên sản phẩm"
                              class="mx-4 pt-5 ma-0 pb-2"
                              hide-details=""
                            />
                          </template>
                          <!-- body -->
                          <template
                            v-slot:item.img_url="{ item }">
                            <v-img
                              :lazy-src="item.img_url.thumbs"
                              :src="item.img_url.thumbs"
                              max-height="70"
                              max-width="70"
                              class="ma-1 rounded-lg"
                            />
                          </template>
                          <template v-slot:item.specification="{ item }">
                            {{
                              item.specification.DVT.length > 0
                                ? item.specification.DVT.join(", ")
                                : ""
                            }}
                          </template>
                          <template v-slot:item.wholesale_price="{ item }">
                            {{ formatPrice(item.wholesale_price, 0) }}
                          </template>
                          <template v-slot:item.retail_price="{ item }">
                            {{ formatPrice(item.retail_price, 0) }}
                          </template>
                          <template v-slot:item.real_price="{ item }">
                            {{ formatPrice(item.real_price, 0) }}
                          </template>
                          <template v-slot:item.quatity_inventory="{ item }">
                            {{ formatPrice(item.quatity_inventory, 0) }}
                          </template>
                        </v-data-table>
                      </v-col>
                    </v-row>
                  </v-expansion-panel-content>
                </v-expansion-panel>

                <v-expansion-panel>
                  <v-expansion-panel-header>Panel 3</v-expansion-panel-header>
                  <v-expansion-panel-content>
                    Some content
                  </v-expansion-panel-content>
                </v-expansion-panel>
              </v-expansion-panels>
            </div>
          </v-col>
        </v-row>

        <v-divider class="mt-5" />
      </v-form>
    </base-material-card>
    <!-- dialog -->
    <v-row>
      <addStorage
        ref="addStorage"
        :v-model="dialogStorage"
      />
    </v-row>
    <v-row>
      <dialogConfirm
        ref="dialogConfirm"
        :v-model="dialogConfirm"
      />
    </v-row>

    <v-row>
      <dialogAlert
        ref="dialogAlert"
        :v-model="dialogAlert"
      />
    </v-row>

    <v-row>
      <snackbarNew
        ref="snackNotification"
        :v-model="snackbar"
      />
    </v-row>
  </v-container>
</template>

<script>
  import axios from 'axios'
  import config from '../../config/config.js'
  import snackbarNew from '../dashboard/component/snackbarNew'
  import dialogConfirm from '../dashboard/component/dialogConfirm'
  import dialogAlert from '../dashboard/component/dialogAlert'

  export default {
    layout: 'addstorage',
    components: {
      snackbarNew,
      dialogConfirm,
      dialogAlert,
    },
    data () {
      return {
        search: '',
        dialog: false,
        singleSelect: false,
        selected: [],
        dialogStorage: false,
        dialogConfirm: false,
        dialogAlert: false,
        pageCount: 0,
        itemPerPage: 5,
        bankList: [],
        productList: [],
        color: null,
        colors: ['purple', 'info', 'success', 'warning', 'error'],
        top: true,
        bottom: false,
        left: false,
        right: false,
        snackbar: false,
        snackbarContent:
          'Đã có lỗi hệ thống xảy ra, vui lòng kiểm tra lại hoặc liên hệ với admin!!!',
        pagination: {
          ascending: true,
          sortBy: 'name',
          rowsPerPage: 10,
          page: 1,
        },
        searchDVT: '',
        searchInput: '',
        imageStore1: 'https://cf.shopee.vn/file/8add33398aa57b801cb8b05c87c8532d',
        specs: [],
        panel: [0, 1, 2],
        readonly: false,
        customerModel: {
          code: '',
          name: '',
          phone: '',
          address: '',
          delivery_name: '',
          delivery_address: '',
          delivery_phone: '',
          delivery_time: '',
        },
        productList: [
            {
                "id":34,
                "code":"SP143",
                "name":"khô gà lá chanh",
                "category_code":"Bánh Gấu",
                "specification":{
                  "DVT":[
                      "GÓI",
                      "THÙNG",
                      "KG"
                  ]
                },
                "net":"100",
                "wholesale_price":"0",
                "retail_price":"0",
                "quota_whosale":"0",
                "quatity_inventory":"20",
                "note":{
                  "note":"1111"
                },
                "img_url":{
                  "thumbs":"https://cf.shopee.vn/file/8add33398aa57b801cb8b05c87c8532d"
                },
                "real_price":"25000",
                "create_date":"2020-10-20T08:03:26.000Z",
                "create_user":1,
                "update_date":"2020-10-28T10:34:14.000Z",
                "suppiler_code":"NCC1"
            },
            {
                "id":35,
                "code":"SP145",
                "name":"BÁNH GẤU NHÂN KEM",
                "category_code":"Bánh Gấu",
                "specification":{
                  "DVT":[
                      "GÓI",
                      "THÙNG",
                      "KG"
                  ]
                },
                "net":"150",
                "wholesale_price":"11",
                "retail_price":"33",
                "quota_whosale":"10",
                "quatity_inventory":"1310",
                "note":{
                  "note":"333"
                },
                "img_url":{
                  "thumbs":"https://cf.shopee.vn/file/8add33398aa57b801cb8b05c87c8532d"
                },
                "real_price":"25000",
                "create_date":"2020-10-20T08:05:51.000Z",
                "create_user":1,
                "update_date":"2020-10-28T10:52:26.000Z",
                "suppiler_code":"NCC1"
            },
            {
                "id":64,
                "code":"SP353",
                "name":"Khô gà lá chanh",
                "category_code":"Bánh Gấu",
                "specification":{
                  "DVT":[
                      "GÓI"
                  ]
                },
                "net":"100",
                "wholesale_price":"0",
                "retail_price":"0",
                "quota_whosale":"0",
                "quatity_inventory":"2200",
                "note":{
                  "note":""
                },
                "img_url":{
                  "thumbs":"https://cf.shopee.vn/file/8add33398aa57b801cb8b05c87c8532d"
                },
                "real_price":null,
                "create_date":"2020-10-28T02:40:14.000Z",
                "create_user":1,
                "update_date":"2020-10-28T10:52:43.000Z",
                "suppiler_code":"undefined"
            },
            {
                "id":33,
                "code":"SP141",
                "name":"Khô gà lá chanh",
                "category_code":"Bánh Gấu",
                "specification":{
                  "DVT":[
                      "GÓI",
                      "THÙNG",
                      "KG"
                  ]
                },
                "net":"50",
                "wholesale_price":"90",
                "retail_price":"140",
                "quota_whosale":"100",
                "quatity_inventory":"133",
                "note":{
                  "note":"Hàng bán tết"
                },
                "img_url":{
                  "thumbs":"https://cf.shopee.vn/file/8add33398aa57b801cb8b05c87c8532d"
                },
                "real_price":"111",
                "create_date":"2020-10-20T07:57:39.000Z",
                "create_user":1,
                "update_date":"2020-10-21T09:29:36.000Z",
                "suppiler_code":"HỘP"
            },
            {
                "id":39,
                "code":"SP174",
                "name":"Nam Nguyen",
                "category_code":"Bánh Gấu,Khô Gà",
                "specification":{
                  "DVT":[
                      "GÓI"
                  ]
                },
                "net":"11",
                "wholesale_price":"1",
                "retail_price":"1",
                "quota_whosale":"11",
                "quatity_inventory":"0",
                "note":{
                  "note":"ghi chu"
                },
                "img_url":{
                  "thumbs":"https://cf.shopee.vn/file/8add33398aa57b801cb8b05c87c8532d"
                },
                "real_price":"11",
                "create_date":"2020-10-23T06:59:12.000Z",
                "create_user":1,
                "update_date":"2020-10-23T06:59:12.000Z",
                "suppiler_code":"NCC1"
            },
            {
                "id":67,
                "code":"SP517",
                "name":"Cơm cháy mắm hành",
                "category_code":"Bánh Gấu",
                "specification":{
                  "DVT":[
                      "GÓI",
                      "THÙNG",
                      "KG",
                      "CÁI",
                      "HỘP"
                  ]
                },
                "net":"100",
                "wholesale_price":"10000",
                "retail_price":"20000",
                "quota_whosale":"10",
                "quatity_inventory":"0",
                "note":{
                  "note":""
                },
                "img_url":{
                  "thumbs":"https://cf.shopee.vn/file/8add33398aa57b801cb8b05c87c8532d"
                },
                "real_price":"25000",
                "create_date":"2020-10-28T08:40:05.000Z",
                "create_user":1,
                "update_date":"2020-10-28T08:40:05.000Z",
                "suppiler_code":"NCC1"
            },
            {
                "id":63,
                "code":"SP317",
                "name":"Thêm mới",
                "category_code":"Bánh Gấu",
                "specification":{
                  "DVT":[
                      "GÓI"
                  ]
                },
                "net":"11",
                "wholesale_price":"0",
                "retail_price":"0",
                "quota_whosale":"0",
                "quatity_inventory":"0",
                "note":{
                  "note":""
                },
                "img_url":{
                  "thumbs":"https://cf.shopee.vn/file/8add33398aa57b801cb8b05c87c8532d"
                },
                "real_price":"0",
                "create_date":"2020-10-27T08:12:20.000Z",
                "create_user":1,
                "update_date":"2020-10-27T08:12:20.000Z",
                "suppiler_code":"NCC1"
            }
          ],
        specification: ['GÓI', 'THÙNG', 'KG', 'CÁI', 'HỘP'],
        suppiler_code: ['NCC1'],
        category: [],
        seqOb: {
          seqCode: 'SP',
          seqName: 'product_code_seq',
          seqDigitNumber: 5,
        },
        productStorageModel: {
          code: '',
          name_product: '',
          category_code: '',
          specification: '',
          net: '',
          wholesale_price: '0',
          retail_price: '0',
          quota_whosale: '0',
          quatity_inventory: '0',
          note: '',
          img_url: '{ "A": "B" }',
          real_price: '0',
          create_user: '1',
          receipt_suppiler: '',
        },
        nameRules: [(v) => !!v || 'The field is required'],
        numberRule: [(v) => !!v || 'The field is required'],
        priceRule: [(v) => !!v || 'The field is required'],
        specRule: [(v) => !!v || 'The field is required'],
        dvtRules: [(v) => !!v || 'The field is required'],
      }
    },
    computed: {},
    mounted: function () {}, // end method
    created () {
      this.getProductList()
      this.getSpecs()
      this.getCategories()
    }, // end data
    methods: {
      validate () {
        let flag = true
        this.$refs.form.validate()
        this.$nextTick(function () {
          // Product name

          if (!this.$refs.receiptquatity.validate()) {
            flag = false
            this.$refs.receiptquatity.focus()
          } else if (!this.$refs.receiptprice.validate()) {
            flag = false
            this.$refs.receiptprice.focus()
          } else if (!this.$refs.receipspec.validate()) {
            flag = false
            this.$refs.receipspec.focus()
          }

          // //Ton kho toi thieu
          // else if(!this.$refs.qtyinventory.validate()){
          //   this.$refs.qtyinventory.focus();
          // }
          // else if (!this.$refs.category.validate()) {
          //   flag = false;
          //   this.$refs.category.focus();
          // } else if (!this.$refs.suppiler.validate()) {
          //   flag = false;
          //   this.$refs.suppiler.focus();
          // }
          return flag
        })
      },
      async insertStorage () {
        // console.log("Valid store ok:" + this.validate());
        // eslint-disable-next-line no-unused-vars
        const chitieu = JSON.stringify(this.chitieuModel)
        const seft = this
        this.productStorageModel.note = JSON.stringify({
          note: this.productStorageModel.note,
        })
        this.productStorageModel.specification = JSON.stringify({
          DVT: this.productStorageModel.specification,
        })
        this.productStorageModel.receipt_suppiler = JSON.stringify({
          NCC: this.productStorageModel.receipt_suppiler,
        })
        // this.productStorageModel.previous_price = this.productStorageModel.real_price;
        await axios
          .post(
            config.API_FAMILY + '/api/insertStorage',
            this.productStorageModel,
          )
          .then(function (response) {
            seft.dialog = false
            console.log('Valid store ok')
            console.log(response.data.data)
            seft.$emit('refeshList')
          })
      },
      refeshList () {
        this.dialog = false
        this.$emit('refeshList')
      },
      productChange (object) {
        console.log(object)
        console.log('Code')
        console.log(object.code)
        this.productStorageModel.code = object.code

        this.productStorageModel.product_code = object.code
        this.productStorageModel.quatity_inventory = object.quatity_inventory
        this.productStorageModel.category_code = object.category_code
        this.productStorageModel.suppiler_code = object.suppiler_code

        this.productStorageModel.previous_price = object.real_price
        this.productStorageModel.stock_current = object.quatity_inventory

      // quatity_inventory
      },
      async getSpecs () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/getSpecs')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.specs = response.data.data
          })
      },
      async getProductList () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/getListProduct')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.productList = response.data.data
          })
      },
      
      async getCategories () {
        const seft = this
        await axios
          .get(config.API_FAMILY + '/api/getCategories')
          .then(function (response) {
            // this.insertChitieuDialog.dialog = false;
            console.log(response.data.data)
            seft.category = response.data.data
          })
      },
      chooseImage (ref) {
        if (ref === 'THUMB_1') {
          this.$refs.fileInput1.click()
        }
        if (ref === 'THUMB_2') {
          this.$refs.fileInput2.click()
        }
        if (ref === 'THUMB_3') {
          this.$refs.fileInput3.click()
        }
        if (ref === 'THUMB_4') {
          this.$refs.fileInput4.click()
        }
        if (ref === 'THUMB_5') {
          this.$refs.fileInput5.click()
        }
      },
      onSelectFile1 () {
        console.log('onSelectFile1')
        const input = this.$refs.fileInput1
        const files = input.files
        if (files && files[0]) {
          const reader = new FileReader()
          reader.onload = (e) => {
            this.imageData1 = e.target.result
          }
          reader.readAsDataURL(files[0])
          this.$emit('input', files[0])
        }
      },
    }, // end created
  } // End exxport default
</script>
<style scroped>

</style>
